/*
 * Copyright (c) 2012 pocketservices GmbH
 * $Id: Person.java 830 2012-06-02 07:11:34Z bjjl $
 */
package odbbug;

import java.io.Serializable;
import javax.persistence.*;

/**
 *
 * @author bjjl
 */
@Entity
public class Person extends BaseObject implements Serializable {

  @Id
  private String nickname;
  private String password;
  private byte[] salt;

  public Person() {
  }

  public Person(String nickname) {
    this.nickname = nickname;
  }

  public String getPassword() {
    return password;
  }

  public void setPassword(String password) {
    Security.HashWithSalt hashWithSalt = Security.getHashWithSalt(password);
    this.password = hashWithSalt.hash;
    this.salt = hashWithSalt.salt;
  }
}
