/*
 * Copyright (c) 2012 pocketservices GmbH
 * $Id: Security.java 610 2012-01-15 11:34:43Z bjjl $
 */
package odbbug;

import java.io.UnsupportedEncodingException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.Random;

/**
 *
 * @author bjjl
 */
public class Security {

  public static class HashWithSalt {

    public String hash;
    public byte[] salt;
  }

  public static HashWithSalt getHashWithSalt(String password) {
    return getHashWithSalt(password, null);
  }

  public static String getHash(String password, byte[] insalt) {
    return getHashWithSalt(password, insalt).hash;
  }

  private static HashWithSalt getHashWithSalt(String password, byte[] insalt) {
    HashWithSalt ret = new HashWithSalt();
    String hash = "";
    byte[] salt;
    if (insalt == null) {
      Random rand = new Random();
      salt = new byte[12];
      rand.nextBytes(salt);
    } else {
      salt = insalt;
    }
    try {
      MessageDigest digest = MessageDigest.getInstance("SHA-256");
      digest.reset();
      digest.update(salt);
      byte[] s = digest.digest(password.getBytes("UTF-8"));
      for (int i = 0; i < 1000; i++) {
        digest.reset();
        s = digest.digest(s);
      }
      for (int i = 0; i < s.length; i++) {
        hash += Integer.toHexString((0x000000ff & s[i]) | 0xffffff00).substring(6);
      }
    } catch (UnsupportedEncodingException ex) {
    } catch (NoSuchAlgorithmException ex) {
    } finally {
      ret.hash = hash;
      ret.salt = salt;
      return ret;
    }
  }
}
